/* --------------------------------------------------------------  */
/* (C)Copyright 2007                                               */
/* International Business Machines Corporation                     */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */

#ifndef __BLAS_CALLBACK_H__
#define __BLAS_CALLBACK_H__

#include <stddef.h>
#include <stdint.h>
#include <libspe2.h>

typedef void spes_info_handle_t;
typedef void spe_info_handle_t;

/* Callbacks */

typedef void (*BLAS_SPE_SCHEDULE_CB) (spe_info_handle_t*, 
                spe_program_handle_t*, unsigned int /* runflags */, 
                void* /* argp */, void* /* envp */);
typedef void (*BLAS_SPE_WAIT_CB) (spe_info_handle_t*);
typedef int (*BLAS_NUM_SPES_CB) (spes_info_handle_t*);
typedef spe_info_handle_t* (*BLAS_GET_SPE_INFO_CB) (spes_info_handle_t*, 
                                            int /* index */);

typedef void* (*BLAS_Malloc_CB) (size_t);
typedef void  (*BLAS_Free_CB) (void*);

void blas_register_spe(spes_info_handle_t*, BLAS_SPE_SCHEDULE_CB, BLAS_SPE_WAIT_CB,
                       BLAS_NUM_SPES_CB, BLAS_GET_SPE_INFO_CB);

void blas_register_mem(BLAS_Malloc_CB, BLAS_Free_CB);

#endif
